//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39E326BA031B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39E326BA031B.cm

//## begin module%39E326BA031B.cp preserve=no
//## end module%39E326BA031B.cp

//## Module: DataSetBase%39E326BA031B; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/DataSetBase.h

#ifndef DATASETBASE_H
#define DATASETBASE_H 1

//## begin module%39E326BA031B.additionalIncludes preserve=no
//## end module%39E326BA031B.additionalIncludes

//## begin module%39E326BA031B.includes preserve=yes
//## end module%39E326BA031B.includes

// Error
#include <XSUtil/Error/Error.h>
// string
#include <string>
// map
#include <map>
// SpectralData
#include <XSModel/Data/SpectralData.h>

class DataPrototype;

//## begin module%39E326BA031B.declarations preserve=no
//## end module%39E326BA031B.declarations

//## begin module%39E326BA031B.additionalDeclarations preserve=yes
//## end module%39E326BA031B.additionalDeclarations


//## begin DataSetBase%39E31E6C02B4.preface preserve=yes
//## end DataSetBase%39E31E6C02B4.preface

//## Class: DataSetBase%39E31E6C02B4
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39E372E4007F;std::map { -> }

class DataSetBase 
{
  //## begin DataSetBase%39E31E6C02B4.initialDeclarations preserve=yes
  //## end DataSetBase%39E31E6C02B4.initialDeclarations

  public:
    //## Class: NoSuchSpectrum%3A2BD4AA034E
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoSuchSpectrum : public YellowAlert  //## Inherits: <unnamed>%3A2BD4AA0354
    {
      public:
        //## Constructors (specified)
          //## Operation: NoSuchSpectrum%3A2BD4AA0360
          NoSuchSpectrum (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      DataSetBase(const DataSetBase &right);

    //## Constructors (specified)
      //## Operation: DataSetBase%3A1C3F020036
      DataSetBase (const string& name, size_t index, DataPrototype* proto);

    //## Destructor (generated)
      ~DataSetBase();

    //## Assignment Operation (generated)
      DataSetBase & operator=(const DataSetBase &right);


    //## Other Operations (specified)
      //## Operation: destroy%3A37926A02D5
      //## Exceptions: ()
      void destroy () throw ();

      //## Operation: closeFiles%3A393F910022
      void closeFiles ();

      //## Operation: multiSpectralData%3A6DB4A7011A
      std::map<size_t,SpectralData*>& multiSpectralData ();

      //## Operation: spectralData%3A6DB640002D
      SpectralData* spectralData ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: dataName%3A1C13210393
      const string& dataName () const;
      void dataName (const string& value);

      //## Attribute: legalStartChan%3A48DDA5030D
      const size_t legalStartChan () const;
      void legalStartChan (size_t value);

      //## Attribute: legalEndChan%3A48DDB902A6
      const size_t legalEndChan () const;
      void legalEndChan (size_t value);

      //## Attribute: dataGroup%3AAE55530031
      size_t dataGroup () const;
      void dataGroup (size_t value);

      //## Attribute: index%3BB208D802FD
      const size_t index () const;
      void index (size_t value);

      //## Attribute: origNumSources%3C76A970013A
      const int origNumSources () const;
      void origNumSources (int value);

      //## Attribute: outputFileName%3EDCC21D0042
      const string& outputFileName () const;
      void outputFileName (const string& value);

      //## Attribute: outputBckFileName%3EDCEA7F022B
      const string& outputBckFileName () const;
      void outputBckFileName (const string& value);

      //## Attribute: aScaleIsKeyword%3F7C72E90332
      bool aScaleIsKeyword () const;
      void aScaleIsKeyword (bool value);

      //## Attribute: bScaleIsKeyword%3F7C732F01F4
      bool bScaleIsKeyword () const;
      void bScaleIsKeyword (bool value);

      //## Attribute: runPath%3F983A100333
      const string& runPath () const;
      void runPath (const string& value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::<unnamed>%39E31FDB0070
      //## Role: DataSetBase::spectralData%39E31FDB0072
      const SpectralData* spectralData () const;
      void spectralData (SpectralData* value);

      //## Association: XSModel::Data::<unnamed>%39E32110011B
      //## Role: DataSetBase::protoType%39E321110125
      const DataPrototype* protoType () const;
      void setProtoType (DataPrototype* value);

      //## Association: XSModel::Data::<unnamed>%39E36C550377
      //## Role: DataSetBase::multiSpectralData%39E36C5700BA
      //## Qualifier: index%39E36D2C01D4; size_t
      const std::map<size_t, SpectralData*>& multiSpectralData () const;
      void multiSpectralData (const std::map<size_t, SpectralData*>& value);
      SpectralData*& multiSpectralData (size_t index);

      //## Association: XSModel::Data::<unnamed>%3EFC8161026E
      //## Role: DataSetBase::modelNamesForFake%3EFC81630059
      //## Qualifier: index%3EFC81800329; size_t
      const std::vector<std::string>& modelNamesForFake () const;
      void setModelNamesForFake (const std::vector<std::string>& value);
      const std::string& modelNamesForFake (size_t index) const;
      void modelNamesForFake (size_t index, const std::string& value);

  public:
    // Additional Public Declarations
      //## begin DataSetBase%39E31E6C02B4.public preserve=yes
      //## end DataSetBase%39E31E6C02B4.public

  protected:
    // Additional Protected Declarations
      //## begin DataSetBase%39E31E6C02B4.protected preserve=yes
      //## end DataSetBase%39E31E6C02B4.protected

  private:

    //## Other Operations (specified)
      //## Operation: swap%39E3250901DB
      //## Exceptions: ()
      void swap (DataSetBase& right) throw ();

    // Additional Private Declarations
      //## begin DataSetBase%39E31E6C02B4.private preserve=yes
      //## end DataSetBase%39E31E6C02B4.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin DataSetBase::dataName%3A1C13210393.attr preserve=no  public: string {U} 
      string m_dataName;
      //## end DataSetBase::dataName%3A1C13210393.attr

      //## begin DataSetBase::legalStartChan%3A48DDA5030D.attr preserve=no  public: size_t {U} 
      size_t m_legalStartChan;
      //## end DataSetBase::legalStartChan%3A48DDA5030D.attr

      //## begin DataSetBase::legalEndChan%3A48DDB902A6.attr preserve=no  public: size_t {U} 0
      size_t m_legalEndChan;
      //## end DataSetBase::legalEndChan%3A48DDB902A6.attr

      //## begin DataSetBase::dataGroup%3AAE55530031.attr preserve=no  public: size_t {U} 1
      size_t m_dataGroup;
      //## end DataSetBase::dataGroup%3AAE55530031.attr

      //## begin DataSetBase::index%3BB208D802FD.attr preserve=no  public: size_t {U} 
      size_t m_index;
      //## end DataSetBase::index%3BB208D802FD.attr

      //## begin DataSetBase::origNumSources%3C76A970013A.attr preserve=no  public: int {U} 1
      int m_origNumSources;
      //## end DataSetBase::origNumSources%3C76A970013A.attr

      //## begin DataSetBase::outputFileName%3EDCC21D0042.attr preserve=no  public: string {U} 
      string m_outputFileName;
      //## end DataSetBase::outputFileName%3EDCC21D0042.attr

      //## begin DataSetBase::outputBckFileName%3EDCEA7F022B.attr preserve=no  public: string {U} 
      string m_outputBckFileName;
      //## end DataSetBase::outputBckFileName%3EDCEA7F022B.attr

      //## begin DataSetBase::aScaleIsKeyword%3F7C72E90332.attr preserve=no  public: bool {U} 
      bool m_aScaleIsKeyword;
      //## end DataSetBase::aScaleIsKeyword%3F7C72E90332.attr

      //## begin DataSetBase::bScaleIsKeyword%3F7C732F01F4.attr preserve=no  public: bool {U} 
      bool m_bScaleIsKeyword;
      //## end DataSetBase::bScaleIsKeyword%3F7C732F01F4.attr

      //## begin DataSetBase::runPath%3F983A100333.attr preserve=no  public: string {U} 
      string m_runPath;
      //## end DataSetBase::runPath%3F983A100333.attr

    // Data Members for Associations

      //## Association: XSModel::Data::<unnamed>%39E31FDB0070
      //## begin DataSetBase::spectralData%39E31FDB0072.role preserve=no  public: SpectralData { -> 1RHgN}
      SpectralData* m_spectralData;
      //## end DataSetBase::spectralData%39E31FDB0072.role

      //## Association: XSModel::Data::<unnamed>%39E32110011B
      //## begin DataSetBase::protoType%39E321110125.role preserve=no  public: DataPrototype { -> 1RFHgN}
      DataPrototype* m_protoType;
      //## end DataSetBase::protoType%39E321110125.role

      //## Association: XSModel::Data::<unnamed>%39E36C550377
      //## begin DataSetBase::multiSpectralData%39E36C5700BA.role preserve=no  public: SpectralData { -> 1..nRFHgN}
      std::map<size_t, SpectralData*> m_multiSpectralData;
      //## end DataSetBase::multiSpectralData%39E36C5700BA.role

      //## Association: XSModel::Data::<unnamed>%3EFC8161026E
      //## begin DataSetBase::modelNamesForFake%3EFC81630059.role preserve=no  public: std::string { -> 1..nVHgN}
      std::vector<std::string> m_modelNamesForFake;
      //## end DataSetBase::modelNamesForFake%3EFC81630059.role

    // Additional Implementation Declarations
      //## begin DataSetBase%39E31E6C02B4.implementation preserve=yes
      //## end DataSetBase%39E31E6C02B4.implementation

};

//## begin DataSetBase%39E31E6C02B4.postscript preserve=yes
//## end DataSetBase%39E31E6C02B4.postscript

// Class DataSetBase::NoSuchSpectrum 

// Class DataSetBase 

//## Get and Set Operations for Class Attributes (inline)

inline const string& DataSetBase::dataName () const
{
  //## begin DataSetBase::dataName%3A1C13210393.get preserve=no
  return m_dataName;
  //## end DataSetBase::dataName%3A1C13210393.get
}

inline void DataSetBase::dataName (const string& value)
{
  //## begin DataSetBase::dataName%3A1C13210393.set preserve=no
  m_dataName = value;
  //## end DataSetBase::dataName%3A1C13210393.set
}

inline const size_t DataSetBase::legalStartChan () const
{
  //## begin DataSetBase::legalStartChan%3A48DDA5030D.get preserve=no
  return m_legalStartChan;
  //## end DataSetBase::legalStartChan%3A48DDA5030D.get
}

inline void DataSetBase::legalStartChan (size_t value)
{
  //## begin DataSetBase::legalStartChan%3A48DDA5030D.set preserve=no
  m_legalStartChan = value;
  //## end DataSetBase::legalStartChan%3A48DDA5030D.set
}

inline const size_t DataSetBase::legalEndChan () const
{
  //## begin DataSetBase::legalEndChan%3A48DDB902A6.get preserve=no
  return m_legalEndChan;
  //## end DataSetBase::legalEndChan%3A48DDB902A6.get
}

inline void DataSetBase::legalEndChan (size_t value)
{
  //## begin DataSetBase::legalEndChan%3A48DDB902A6.set preserve=no
  m_legalEndChan = value;
  //## end DataSetBase::legalEndChan%3A48DDB902A6.set
}

inline size_t DataSetBase::dataGroup () const
{
  //## begin DataSetBase::dataGroup%3AAE55530031.get preserve=no
  return m_dataGroup;
  //## end DataSetBase::dataGroup%3AAE55530031.get
}

inline const size_t DataSetBase::index () const
{
  //## begin DataSetBase::index%3BB208D802FD.get preserve=no
  return m_index;
  //## end DataSetBase::index%3BB208D802FD.get
}

inline void DataSetBase::index (size_t value)
{
  //## begin DataSetBase::index%3BB208D802FD.set preserve=no
  m_index = value;
  //## end DataSetBase::index%3BB208D802FD.set
}

inline const int DataSetBase::origNumSources () const
{
  //## begin DataSetBase::origNumSources%3C76A970013A.get preserve=no
  return m_origNumSources;
  //## end DataSetBase::origNumSources%3C76A970013A.get
}

inline void DataSetBase::origNumSources (int value)
{
  //## begin DataSetBase::origNumSources%3C76A970013A.set preserve=no
  m_origNumSources = value;
  //## end DataSetBase::origNumSources%3C76A970013A.set
}

inline const string& DataSetBase::outputFileName () const
{
  //## begin DataSetBase::outputFileName%3EDCC21D0042.get preserve=no
  return m_outputFileName;
  //## end DataSetBase::outputFileName%3EDCC21D0042.get
}

inline void DataSetBase::outputFileName (const string& value)
{
  //## begin DataSetBase::outputFileName%3EDCC21D0042.set preserve=no
  m_outputFileName = value;
  //## end DataSetBase::outputFileName%3EDCC21D0042.set
}

inline const string& DataSetBase::outputBckFileName () const
{
  //## begin DataSetBase::outputBckFileName%3EDCEA7F022B.get preserve=no
  return m_outputBckFileName;
  //## end DataSetBase::outputBckFileName%3EDCEA7F022B.get
}

inline void DataSetBase::outputBckFileName (const string& value)
{
  //## begin DataSetBase::outputBckFileName%3EDCEA7F022B.set preserve=no
  m_outputBckFileName = value;
  //## end DataSetBase::outputBckFileName%3EDCEA7F022B.set
}

inline bool DataSetBase::aScaleIsKeyword () const
{
  //## begin DataSetBase::aScaleIsKeyword%3F7C72E90332.get preserve=no
  return m_aScaleIsKeyword;
  //## end DataSetBase::aScaleIsKeyword%3F7C72E90332.get
}

inline void DataSetBase::aScaleIsKeyword (bool value)
{
  //## begin DataSetBase::aScaleIsKeyword%3F7C72E90332.set preserve=no
  m_aScaleIsKeyword = value;
  //## end DataSetBase::aScaleIsKeyword%3F7C72E90332.set
}

inline bool DataSetBase::bScaleIsKeyword () const
{
  //## begin DataSetBase::bScaleIsKeyword%3F7C732F01F4.get preserve=no
  return m_bScaleIsKeyword;
  //## end DataSetBase::bScaleIsKeyword%3F7C732F01F4.get
}

inline void DataSetBase::bScaleIsKeyword (bool value)
{
  //## begin DataSetBase::bScaleIsKeyword%3F7C732F01F4.set preserve=no
  m_bScaleIsKeyword = value;
  //## end DataSetBase::bScaleIsKeyword%3F7C732F01F4.set
}

inline const string& DataSetBase::runPath () const
{
  //## begin DataSetBase::runPath%3F983A100333.get preserve=no
  return m_runPath;
  //## end DataSetBase::runPath%3F983A100333.get
}

inline void DataSetBase::runPath (const string& value)
{
  //## begin DataSetBase::runPath%3F983A100333.set preserve=no
  m_runPath = value;
  //## end DataSetBase::runPath%3F983A100333.set
}

//## Get and Set Operations for Associations (inline)

inline const SpectralData* DataSetBase::spectralData () const
{
  //## begin DataSetBase::spectralData%39E31FDB0072.get preserve=no
  return m_spectralData;
  //## end DataSetBase::spectralData%39E31FDB0072.get
}

inline void DataSetBase::spectralData (SpectralData* value)
{
  //## begin DataSetBase::spectralData%39E31FDB0072.set preserve=no
  m_spectralData = value;
  //## end DataSetBase::spectralData%39E31FDB0072.set
}

inline const DataPrototype* DataSetBase::protoType () const
{
  //## begin DataSetBase::protoType%39E321110125.get preserve=no
  return m_protoType;
  //## end DataSetBase::protoType%39E321110125.get
}

inline void DataSetBase::setProtoType (DataPrototype* value)
{
  //## begin DataSetBase::setProtoType%39E321110125.set preserve=no
  m_protoType = value;
  //## end DataSetBase::setProtoType%39E321110125.set
}

inline const std::map<size_t, SpectralData*>& DataSetBase::multiSpectralData () const
{
  //## begin DataSetBase::multiSpectralData%39E36C5700BA.get preserve=no
  return m_multiSpectralData;
  //## end DataSetBase::multiSpectralData%39E36C5700BA.get
}

inline void DataSetBase::multiSpectralData (const std::map<size_t, SpectralData*>& value)
{
  //## begin DataSetBase::multiSpectralData%39E36C5700BA.set preserve=no
  m_multiSpectralData = value;
  //## end DataSetBase::multiSpectralData%39E36C5700BA.set
}

inline const std::vector<std::string>& DataSetBase::modelNamesForFake () const
{
  //## begin DataSetBase::modelNamesForFake%3EFC81630059.get preserve=no
  return m_modelNamesForFake;
  //## end DataSetBase::modelNamesForFake%3EFC81630059.get
}

inline void DataSetBase::setModelNamesForFake (const std::vector<std::string>& value)
{
  //## begin DataSetBase::setModelNamesForFake%3EFC81630059.set preserve=no
  m_modelNamesForFake = value;
  //## end DataSetBase::setModelNamesForFake%3EFC81630059.set
}

inline const std::string& DataSetBase::modelNamesForFake (size_t index) const
{
  //## begin DataSetBase::modelNamesForFake%3EFC81630059.qualget preserve=no
  return m_modelNamesForFake[index];
  //## end DataSetBase::modelNamesForFake%3EFC81630059.qualget
}

inline void DataSetBase::modelNamesForFake (size_t index, const std::string& value)
{
  //## begin DataSetBase::modelNamesForFake%3EFC81630059.qualset preserve=no
  m_modelNamesForFake[index] = value;
  //## end DataSetBase::modelNamesForFake%3EFC81630059.qualset
}

//## begin module%39E326BA031B.epilog preserve=yes
//## end module%39E326BA031B.epilog


#endif
